
#define DO_PULS 4  //Digital out: via R-C-R (270R, 100nF, 8K2) an Transistor BC639, der Signalleitung auf Masse zieht
#define DI_PULS 2  //Digital IN: Spannung der Signalleitung (Gefiltert über 47K/10n)
#define DI_DOOR 3  //Digital IN: Türkontakt. Schaltet gegen Masse; Über 10K Pullup an 5V. Über 47K an Eingang. Vorsichtshalber: 100nF am Eingang gegen GND

unsigned long t;

//--------------------------------------------------------------------------
void pulsON(void){   //Ausgang auf 5V
//--------------------------------------------------------------------------
   pinMode(DO_PULS, OUTPUT);  
   digitalWrite(DO_PULS, HIGH);
}

//--------------------------------------------------------------------------
void pulsOFF(void){ //Ausgang hochohmig
//--------------------------------------------------------------------------
   pinMode(DO_PULS, INPUT);  
   digitalWrite(DO_PULS, LOW); //Pullup aus
}

//--------------------------------------------------------------------------
void setup() {
//--------------------------------------------------------------------------
    pinMode(DO_PULS, OUTPUT);  
    pinMode(DI_DOOR, INPUT);  
    pinMode(DI_PULS, INPUT);  
    pinMode(3, OUTPUT);  
    t = millis();
}

//--------------------------------------------------------------------------
void loop() {
//--------------------------------------------------------------------------
#define ADRESSE        1 //1..25
#define ZYKLUSZEIT     1 //[ms]
#define PULSZEIT_KURZ 20 //[ms]
#define PULSZEIT_LANG 35 //[ms]
#define PULSABSTAND   50 //[ms] Abstand der steigenden Flanken
#define LANGE_PAUSE  110 //[ms]

static int timer_ms=0;
static byte status=0;

    if ((millis() - t) >= ZYKLUSZEIT) { 
        t += ZYKLUSZEIT;
        
        switch(status) {
        case 0: //warte auf lange Pause
            if (digitalRead(DI_PULS)) {  //TRUE: Leitung hat 5V (kein Puls)
                timer_ms += ZYKLUSZEIT;
                if (timer_ms >= LANGE_PAUSE) status++; 
            } else timer_ms = 0;
            break;
        case 1: //warte auf Startpuls
            if (!digitalRead(DI_PULS)) {
                timer_ms = ADRESSE * PULSABSTAND;
                status++;
            }
            break;
        case 2: //warte auf meinen Zeitschlitz
            timer_ms -= ZYKLUSZEIT;
            if (timer_ms <=0) { //jetzt bin ich dran. Ziehe die Signalleitung auf Masse.
                pulsON();
                timer_ms = digitalRead(DI_DOOR) ? PULSZEIT_LANG :  PULSZEIT_KURZ; //Lege Pulsdauer fest
                status++;
            }
            break;
        case 3: //Warte, bis mein Puls zuende    
            timer_ms -= ZYKLUSZEIT;
            if (timer_ms <=0) {
                pulsOFF();
                timer_ms=0; 
                status=0;
            }
            break;
        default: status=0;    
        }//switch
    }//Zyklus
}
